// Base d'un fichier .c d'une application modev a renommer en ...MV.c
//  en tete___________________________________________
#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"

void inifen();
gboolean action(GtkWidget *widget,gpointer data);
void fraz(GtkWidget *widget,gpointer data);
void init_graph(FENGRA* pfg); 


//              data  specifique **************************
//   struct de toutes les variables necessaires
typedef struct  {
gfloat count;
gfloat altitu0;
gfloat altitu;
gfloat touv;
gfloat vites;
gfloat varalti;
gfloat masse;
gfloat kf; // coef para ferme 0.28
gfloat po; // force pesenteur = masse *g;
gfloat rt; // force trainee = kf/masse * v*v
gfloat fr; // force resultante
gfloat dvdt; // dv/dt = acceleration
char etat[];
} DATA_CHUTE;

//	initialisation des variables
DATA_CHUTE ini_chute = {
0,2500,2500,20,0,0,80,0.28,0,0,0,0,"inactif"
};


//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
#define DEPS(zz) (char*)&ini_chute.zz-(char*)&ini_chute.count
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Periode sec"}, 
{NULL,NULL,NULL,DEPS(altitu0),SAISNUM,20, NULL,"%0.0f","Altitude depart"}, 
{NULL,NULL,NULL,DEPS(touv),SAISNUM,20,NULL, "%0.0f","Ouverture a (en sec)"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(altitu),LIBNUM,20,NULL,"%0.2f", "Altitude en m"}, 
{NULL,NULL,NULL,DEPS(vites),LIBNUM,20,NULL,"%#0.2f", "Vitesse en m/s"}, 
{NULL,NULL,NULL,DEPS(dvdt),LIBNUM,20,NULL,"%#0.2f", "dv/dt =accel"}, 
{NULL,NULL,NULL,DEPS(varalti),LIBNUM,20,NULL,"%#0.2f", "Variation Altitude"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS

//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"fenetre 1",        // pointeur sur titre  fenetre 
180,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
150,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define WIGR   840
#define HEIGR  480
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR+20,	// largeur fenetre 
HEIGR+50,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};

//  fonctions calcul_____________________________________
static float altgra0,altgra1,cougra0,cougra1,vit0,vit1;  // pour graphe
#define COOX(zz) WIGR*zz/360	// 60 secondes
#define COOYalt(zz) HEIGR - HEIGR*zz/4000	// 8000m
#define COOYvit(zz) HEIGR - HEIGR*zz/100

void init_graph( FENGRA* pfg)
{ 
gint y0;//,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// vert
  cairo_set_font_size(cr, 10.0);
  cairo_move_to(cr,100, 20);
  cairo_show_text(cr, "Altitude");
y0=COOYalt(0);
  cairo_move_to(cr,0, y0);
  cairo_show_text(cr, "0");
y0=COOYalt(3000);
  cairo_move_to(cr,0, y0);
  cairo_show_text(cr, "3000");
  cairo_set_source_rgb(cr, 0, 1.0, 1.0);  // bleu-vert
  cairo_move_to(cr,200, 20);
  cairo_show_text(cr, "Vitesse");
y0=COOYvit(20);
  cairo_move_to(cr,0, y0);
  cairo_show_text(cr, "20");
  cairo_destroy(cr);
}

void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(cougra0);
y0=COOYalt(altgra0);
x1=COOX(cougra1);
y1=COOYalt(altgra1);
//choicoul((FENGRA*) pfg,0x0F00);
//gdk_draw_line( pfg->pixmap,pfg->kontext, x0,y0, x1,y1 );
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// vert
  cairo_move_to(cr, x0,y0);
//printf("graph 2\n");
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);
//	cairo_paint (cr);

x0=COOX(cougra0);
y0=COOYvit(vit0);
x1=COOX(cougra1);
y1=COOYvit(vit1);
  cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// bleu-vert
  cairo_move_to(cr, x0,y0);
//printf("graph 2\n");
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}

static int temtouv = 0;
static float  vpar;

	// CALCUL a chaque iteration
static gboolean calcul(DATA_CHUTE* pd)
{
float svalti, dt, v2;
dt = 0.1;
  svalti = pd->altitu;
  altgra0 = pd->altitu;
  cougra0 = pd->count;
  vit0= pd->vites;
//  pd->count=pd->count+1;
  pd->count=pd->count + dt;
pd->po = pd->masse * 9.81;
//  chute libre
	// force gravite po = masse x g ( en reel g varie avec altitude)
	// force trainee rt = K x Vitesse x Vitesse
	// K = coef qui depend de 
         // geometrie de l'objet,densité de l'air (varie selon altitude
	 // surface= section de l'objet
	 // ici K fixe 0.28 
	// force resultante fr = po - rt
	// rt augmente avec carre de la vitesse et tend a s'equilibrer avec po
	// variation de vitesse = dv/dt = acceleration = fr / masse	
	// vitesse = variation pendant dt + vitesse iteration precedente
if ( pd->count < pd->touv )	{
 pd->rt = pd->kf * pd->vites *pd->vites;
 pd->fr = pd->po - pd->rt;
 pd->dvdt = pd->fr / pd->masse;
 pd->vites= vit0 + pd->dvdt * dt;
				}
	// ouverture parachute
	// K passe de 0.28 a 38.75 avec a la fin po=rt et dvdt = 0
	// K = (masse x g) / (vitesse x vitesse)
	// si masse = 80 et vit=4.5 m/s K=38.75
	// K et vitesse varient
	// on fixe arbitrairement une force de trainee
	// que l'on diminue progressivement jusqu'a po
	// et on ajuste la vitesse constante
	// une simulation avec un changement de force de trainee moins brutal
	// serait plus realiste
//else if ( pd->count < pd->touv + 4)	{ //  stabilisation en 4 s = 40 iter
else if ( pd->count >= pd->touv && temtouv < 3)	{ // 
 if ( temtouv == 0)	{
  pd->rt = pd->po * 3;	// force trainee = x fois gravite
  temtouv = 1;
			}
// force trainee converge vers force gravite jusqu'a equilibre
// diminue 1/40 de 2 fois gravite
 if ( temtouv == 2)	{
  pd->rt = pd->rt - ( pd->po  / 20);
  if ( pd->rt < pd->po)	pd->rt = pd->po;
			}
 if ( temtouv == 2 || temtouv == 1)	{
  pd->fr = pd->po - pd->rt;
  pd->dvdt = pd->fr / pd->masse;
  pd->vites= vit0 + pd->dvdt * dt;
  temtouv = 2;
			}
 if ( pd->fr == 0)	{	// equilibre kt = 38.75
  v2 = pd->po / 38.75;   
  vpar = sqrt(v2);
  temtouv = 3;
//printf(" vpar= %f\n", vpar);
			}
					}
else	{
// pd->fr = pd->po - pd->rt;
// pd->dvdt = pd->fr / pd->masse;
 pd->vites= vpar;
	}
pd->altitu = pd->altitu - (pd->vites * dt);
//  pd->altitu=pd->altitu0 -(9.81*pd->count*pd->count)/2;
  altgra1 = pd->altitu;
  cougra1 = pd->count;
  vit1= pd->vites;
  pd->varalti=svalti-pd->altitu;
//char * c_strcpy (char * dest, const char * src);
  strcpy((char*)pd->etat,"en action");
  graph((FENGRA *) &fg);
if (pd->altitu > 0) return TRUE;
else {
  strcpy((char*)pd->etat,"arret");
  return FALSE;
    }
}
//  voir http://www.chimix.com/an4/ba4/t271.htm
/*static gboolean calcul(DATA_CHUTE* pd)
{
float svalti;
  svalti = pd->altitu;
  altgra0 = pd->altitu;
  cougra0 = pd->count;
  vit0= pd->vites;
//  pd->count=pd->count+1;
  pd->count=pd->count+0.1;
  pd->altitu=pd->altitu0 -(9.81*pd->count*pd->count)/2;
  altgra1 = pd->altitu;
  cougra1 = pd->count;
  pd->vites=9.81*pd->count;
  vit1= pd->vites;
  pd->varalti=svalti-pd->altitu;
//char * c_strcpy (char * dest, const char * src);
  strcpy((char*)pd->etat,"en action");
  graph((FENGRA *) &fg);
if (pd->altitu > 0) return TRUE;
else {
  strcpy((char*)pd->etat,"arret");
  return FALSE;
    }
}*/


// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_CHUTE*) &ini_chute);
aff_fen2c_sais((F2C *) &f1,(DATA_CHUTE*) &ini_chute);
gtk_widget_show_all(f1.win);
//cre_fen2c_sais( (F2C *) &f2,(DATA_CHUTE*) &ini_chute2);
//gtk_widget_show_all(f2.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE,ret2 = FALSE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_CHUTE*) &ini_chute) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_CHUTE*) &ini_chute);
	}
/*if ( ret2) {
	if ( calcul2( (DATA_CHUTE*) &ini_chute2) == FALSE)
	ret2 = FALSE;
	aff_fen2c_sais((F2C *) &f2,(DATA_CHUTE*) &ini_chute2);
	}*/
//printf("count %f \n",ini_chute.count);
if ( !ret1 && !ret2)	{
	fstop(NULL,NULL);
	return FALSE;
			}
return TRUE;
}

void fraz(GtkWidget *widget,gpointer data)
{
DATA_CHUTE* pd = &ini_chute;
pd->altitu=pd->altitu0;
pd->count =0;
pd->vites = 0;
pd->varalti = 0;
//printf("raz alt %0.0f pd= %0X\n",pd->altitu0,(unsigned int)pd);
//printf(" tablig= %0X\n",(unsigned int)&ini_f1[0]);
//printf(" fen1= %0X\n",(unsigned int)&f1);
strcpy((char*)pd->etat,"en action");
temtouv = 0;
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_CHUTE*) &ini_chute);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(fg.pixmap);
cairo_set_source_rgb(cr, 0, 0, 0);	
cairo_paint (cr);
gtk_widget_queue_draw (fg.da);  
init_graph( (FENGRA *) &fg.wingrap); 
			}
}

