// Une rivière dont les berges sont parrallèles coule avec une vitesse vc.
// Un nageur nageant avec une vitesse vn traverse la rivière.
// Temps de traversee ? Déplacement par rapport a son point de départ ?
// inspiree de
// http://www.mathcurve.com/courbes2d/nageur/nageur.shtml
// 

#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"

	// fonctions a renseigner obligatoirement
void inifen();
gboolean action(GtkWidget *widget,gpointer data);
void fraz(GtkWidget *widget,gpointer data);

	// autres fonctions
void init_graph(FENGRA* pfg); 

//   struct de toutes les variables necessaires
typedef struct  {
gfloat tps;		// compteur temps 
gfloat largriv;		// largeur rivière
gfloat vitnag;		// vitesse nageur
gfloat vitcou0;		// vitesse courant (au maxi)
gfloat ang;		// angle / rive opposee
gfloat distra;		// distance traversee
gfloat vitcou;		// vitesse courant 
gfloat vitrel;		// vitesse traversee nageur 
gfloat disber;		//  deplacement / départ
char etat[16];
} DATA_NAG;

	// declaration de ini_nag et initialisation des donnees 
DATA_NAG ini_nag = {
0,	//gfloat tps;		// compteur temps
200,	//gfloat largriv;		// largeur rivière
12,	//gfloat vitnag;		// vitesse nageur
30,	//gfloat vitcou0;		// vitesse courant (au maxi)
-30,	//gfloat ang;		// angle / rive opposee
0,	//gfloat distra;		// distance traversee
0,	//gfloat vitcou;		// vitesse courant 
0,	//gfloat vitrel;		// vitesse traversee nageur 
0,	//gfloat disber;		// deplacement / départ
"...",	//char etat[15];
};
	// sauvegarde des donnees de l'iteration N-1
DATA_NAG svnag;

//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
	// macro deplacement dans la structure
	// ici tps premiere variable sert de reference deplacement = 0
#define DEPS(zz) (char*)&ini_nag.zz-(char*)&ini_nag.tps
/* 1 ligne =
NULL,NULL,NULL,deplacement,type donnee,longeur,fonction,format,libelle 
  type donnee (genfen.h) 
  LIBNUM affiche nombre
  SAISNUM donnee float pouvant etre saisie (controle) et afficher
*/
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,DEPS(largriv),SAISNUM,10, NULL,"%0.0f","Largeur riviere en m"}, 
{NULL,NULL,NULL,DEPS(vitnag),SAISNUM,10, NULL,"%0.2f","Vitesse nageur m/mn"}, 
{NULL,NULL,NULL,DEPS(vitcou0),SAISNUM,10, NULL,"%0.2f","Vitesse courant (au maxi) m/mn"}, 
{NULL,NULL,NULL,DEPS(ang),SAISMON,10, NULL,"%0.2f","Angle de direction en degres"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Temps en s"}, 
{NULL,NULL,NULL,DEPS(distra),LIBNUM,20,NULL,"%0.2f", "Distance traversee"}, 
{NULL,NULL,NULL,DEPS(disber),LIBNUM,20,NULL,"%0.2f", "Deplacement / pt depart"}, 
{NULL,NULL,NULL,DEPS(vitcou),LIBNUM,20,NULL,"%#0.2f", "Vitesse courant"}, 
{NULL,NULL,NULL,DEPS(vitrel),LIBNUM,20,NULL,"%#0.2f", "Vitesse de traversee nageur"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
	// toujours finir par cette ligne
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS

//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"Nageur",        // pointeur sur titre  fenetre 
280,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
350,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define HEIGR  200
#define WIGR   5 * HEIGR
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR,	// largeur fenetre 
HEIGR+40,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};


static gfloat delt = 1;	// interval de temps entre 2 iterations

	// variable pour graphe
//static float gdelt0,gdelt1,gdisv10,gdisv11,gdisv20,gdisv21;  // pour graphe
	// macro pour coordonnees graphe
#define LARG	ini_nag.largriv 
#define DECAL  HEIGR
#define COOX(zz) HEIGR*zz/(LARG) + DECAL	// axe x distance long berge
#define COOY(zz) HEIGR - HEIGR*zz/LARG	+ 20 // axe y traversee

	// affiche libelles et echelle sur graphe
void init_graph( FENGRA* pfg)
{ 
gint y0,x0,z;//,y0,x1,y1;
char zn[40];
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
	//berges
  cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);	// blanc
y0=COOY(0);
  cairo_move_to(cr, 0,y0);
  cairo_line_to(cr, WIGR,y0);
//  cairo_stroke(cr);
  cairo_move_to(cr, 0,20);
  cairo_line_to(cr, WIGR,20);
  cairo_stroke(cr);

  cairo_set_font_size(cr, 12.0);
x0=DECAL;
  sprintf(zn,"| %d m",0); 
  cairo_move_to(cr,x0, 10);
  cairo_show_text(cr, zn);

y0=COOY(0) + 10;
  cairo_move_to(cr,x0, y0);
  cairo_show_text(cr, zn);

 z= ini_nag.largriv;
  sprintf(zn,"| %d m",z); 
x0=COOX(z);
  cairo_move_to(cr,x0, 10);
  cairo_show_text(cr, zn);
/*z = MAXTEMPS / 2;
y0=COOY(z);
  sprintf(zn,"-- %d mn",z); 
  cairo_move_to(cr,0, y0);
  cairo_show_text(cr, zn);*/
  cairo_destroy(cr);
}

	//  trace du graphe a partir des donnee de la fonction calcul
void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(svnag.disber);
y0=COOY(svnag.distra);
x1=COOX(ini_nag.disber);
y1=COOY(ini_nag.distra);
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// vert
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}


//  fonctions calcul_____________________________________

//static int varvit = 0;
static float coa,cob,coc;

static gboolean calcul(DATA_NAG* p1)
{
double angle;
float vnag,vnagd;
	// sauve valeur iter -1
memcpy((char*)&svnag,(char*)&ini_nag, sizeof(DATA_NAG));
	// calcul coef variation vitesse v=ax2 +bx +c
if ( p1->tps == 0)	{
 coc = 0;	//p1->vitcou0 / 2;
 cob = p1->vitcou0 / p1->largriv * 4;
 coa = - cob / p1->largriv;
			}
	// incremente compteur temps
p1->tps = p1->tps + delt;

	//  angle du nageur / rive a atteindre 
	//  si < 0 contre courant
angle = p1->ang  * (M_PI/180.0);  // angles en radians
	// composante vitesse nageur
vnag = cos(angle) * p1->vitnag;
p1->vitrel = vnag;
vnagd = sin(angle) * p1->vitnag;
if ( p1->tps == 1)	
printf("ang = %f cos= %f sin = %f vnag = %f vnagd = %f\n", angle, cos(angle), sin(angle), vnag,vnagd); 

	// incremente distance traverse
//p1->distra = p1->distra + (p1->vitnag * delt /(float)60);
p1->distra = p1->distra + (vnag * delt /(float)60);
	// vitesse courant
	//vitesse varie au cours de la traversee de maniere parbollique
	// vmax au milieu de la riviere 0 au depart
p1->vitcou = coa*p1->distra*p1->distra + cob*p1->distra + coc;
	// incremente distance / berge
p1->disber = p1->disber + ((p1->vitcou + vnagd) * delt /(float)60);
//p1->disber = p1->disber + (p1->vitcou * delt /(float)60);
  strcpy((char*)p1->etat,"en nage");
  graph((FENGRA *) &fg);

	// arret quand distance devient nulle
if (p1->distra < p1->largriv) return TRUE;
else {
  strcpy((char*)p1->etat,"ouf !");
  return FALSE;
    }
}

// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_NAG*) &ini_nag);
aff_fen2c_sais((F2C *) &f1,(DATA_NAG*) &ini_nag);
gtk_widget_show_all(f1.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
	// iteration declanchee tous les xx en 1/1000 de seconde
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_NAG*) &ini_nag) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_NAG*) &ini_nag);
	}
if ( !ret1 )	{
	fstop(NULL,NULL);
	return FALSE;
			}
return TRUE;
}

	// on reinitialise (apres saisie)
void fraz(GtkWidget *widget,gpointer data)
{
DATA_NAG* pd = &ini_nag;
pd->tps=0;
pd->distra =0;
pd->disber = 0;
//pd->disv1v2 = 0;
delt = 1;
//varvit = 0;
//strcpy((char*)pd->etat,"en action");
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_NAG*) &ini_nag);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(fg.pixmap);
cairo_set_source_rgb(cr, 0, 0, 0);	
cairo_paint (cr);
gtk_widget_queue_draw (fg.da);  
init_graph( (FENGRA *) &fg.wingrap); 
			}
}

