// panneau solaire (avec calculs sans fondements scientifiques)

#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"

	// fonctions a renseigner obligatoirement
void inifen();
gboolean action(GtkWidget *widget,gpointer data);
void fraz(GtkWidget *widget,gpointer data);

	// autres fonctions
// initialisation du graphe (libelles)
void init_graph(FENGRA* pfg); 
void lidon();
void decoup();

	// variable fichier
extern FILE *fis;
extern char fiecsvs[80];
extern char ze [256];
extern int lz;


//   struct de toutes les variables necessaires
typedef struct  {
gfloat horlog;
gfloat exttemp;	// temperature externe
gfloat extsol;	// quant soleil
gfloat exteaut;	// temperature alimentation eau 
gfloat consom;	// consomme eau

gfloat pantemp;	// temperature panneau
gfloat pansurf;	// surface panneau

gfloat baltemp;	// temperature eau ballon
gfloat baltemploc;	// temperature local ballon
gfloat balvol;	// volume ballon
gfloat pompvit;	// debit pompe
int hjour;	// heure du jour
char etat[20];
char fidon[24]; // fichier donnee
} DATA_PSOL;

	// declaration  et initialisation des donnees 
DATA_PSOL psol = {
0,	//gfloat horlog;
18,	//gfloat exttemp;	// temperature externe
80,	//gfloat extsol;	// quant soleil
16,	//gfloat exteaut;	// temperature alimentation eau 
60,	//gfloat consom;	// consomme eau

58,	//gfloat pantemp;	// temperature panneau
4,	//gfloat pansurf;	// surface panneau

55,	//gfloat baltemp;	// temperature eau ballon
19,	//gfloat baltemploc;	// temperature local ballon
300,	//gfloat balvol;	// volume ballon
240,	//gfloat pompvit;	// debit pompe
0,	//int hjour;	// heure du jour
"attente\0",	//char etat[16];
"...\0",	//char fidon[24]; // fichier donnee
};
	// sauvegarde des donnees de l'iteration N-1
DATA_PSOL svpsol;

//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
	// macro deplacement dans la structure
#define DEPS(zz) (char*)&psol.zz-(char*)&psol.horlog
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,DEPS(fidon),LIBCHAR,24,NULL,"%s", "Fichier de donnee"}, 
{NULL,NULL,NULL,DEPS(hjour),LIBINT,10,NULL,"%d", "Heure du jour"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(extsol),SAISNUM,10,NULL, "%0.2f","Intensite soleil / m2"}, 
{NULL,NULL,NULL,DEPS(exttemp),SAISNUM,10,NULL, "%0.2f","Temperature externe"}, 
{NULL,NULL,NULL,DEPS(exteaut),SAISNUM,10,NULL, "%0.2f","Temp. Alimentation eau"}, 
{NULL,NULL,NULL,DEPS(consom),SAISNUM,10,NULL, "%0.2f","Consommation eau / h"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(balvol),SAISNUM,10,NULL, "%0.2f","Volume ballon"}, 
{NULL,NULL,NULL,DEPS(baltemploc),SAISNUM,10,NULL, "%0.2f","Temperature local ballon"}, 
{NULL,NULL,NULL,DEPS(pansurf),SAISNUM,10,NULL, "%0.2f","Surface panneau m2"}, 
{NULL,NULL,NULL,DEPS(pompvit),SAISNUM,10,NULL, "%0.2f","debit pompe l/h"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},

{NULL,NULL,NULL,DEPS(baltemp),LIBNUM,20,NULL,"%0.2f", "Temperature ballon"}, 
{NULL,NULL,NULL,DEPS(pantemp),LIBNUM,20,NULL,"%0.2f", "Temperature panneau"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Horloge"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS


//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"Panneau Solaire",        // pointeur sur titre  fenetre 
280,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
150,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define WIGR   840
#define HEIGR  480
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR+20,	// largeur fenetre 
HEIGR+50,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};

	// macro pour coordonnees graphe
#define MAXTEMPS	600
//#define COOX(zz) WIGR*zz/psol.dist2ville	// axe x distance
#define COOX(zz) WIGR*zz/MAXTEMPS	// 
#define COOY_Tbal(zz) HEIGR - HEIGR*zz/140	// 
#define COOY_Tpan(zz) HEIGR - HEIGR*zz/140
#define COOY_IS(zz) HEIGR - HEIGR*zz/140
#define COOY_conso(zz) HEIGR - HEIGR*zz/300

void init_graph( FENGRA* pfg)
{ 
gint y0,x0,z;//,y0,x1,y1;
char zn[40];
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
  cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);	// blanc
  cairo_set_font_size(cr, 15.0);
z = MAXTEMPS / 2;
x0=COOX(z);
  sprintf(zn,"| %d h",z/10); 
  cairo_move_to(cr,x0, HEIGR+20);
  cairo_show_text(cr, zn);
z = WIGR - 80;
cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// 
y0=COOY_Tbal(50);
  sprintf(zn,"-- %d ° C",50); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_set_source_rgb(cr, 1.0, 0, 1.0);	// 
y0=COOY_Tpan(100);
  sprintf(zn,"-- %d ° C",100); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_set_source_rgb(cr, 0, 1.0, 0);	// 
y0=COOY_conso(60);
  sprintf(zn,"-- %d l/h",60); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_set_source_rgb(cr, 1.0, 0, 0);	// 
y0=COOY_IS(60);
  sprintf(zn,"-- %d IS",60); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_destroy(cr);
}

void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(svpsol.horlog);
y0=COOY_Tbal(svpsol.baltemp);
x1=COOX(psol.horlog);
y1=COOY_Tbal(psol.baltemp);
  cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

y0=COOY_Tpan(svpsol.pantemp);
y1=COOY_Tpan(psol.pantemp);
  cairo_set_source_rgb(cr, 1.0, 0, 1.0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

y0=COOY_IS(svpsol.consom);
y1=COOY_IS(psol.consom);
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

y0=COOY_IS(svpsol.extsol);
y1=COOY_IS(psol.extsol);
  cairo_set_source_rgb(cr, 1.0, 0, 0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}

static gboolean calcul(DATA_PSOL* pd)
{
float dtconsom, dtvit;	
int dt = 10;
//DATA_PSOL* psv = &svpsol;
	// sauve valeur iter -1
memcpy((char*)&svpsol,(char*)&psol, sizeof(DATA_PSOL));
	//  donnees evoluent suivant fichier
	//  toutes les dt iterations
	// decoupe l'heure en dt iteration
if ( fis != NULL && ((int)pd->horlog  % dt) == 0)	{
	lidon();
			}
	// toujours
	// perte temp ballon
pd->baltemp = pd->baltemp - ((pd->baltemp-pd->baltemploc) / (100*dt)); // par dt
	// consom dtconsom
dtconsom= pd->consom / dt;
pd->baltemp = (pd->baltemp*(pd->balvol-dtconsom) + pd->exteaut*dtconsom) / pd->balvol;
	// pas de soleil
	// perte temp panneau
if ( pd->extsol == 0)
 pd->pantemp = pd->pantemp - ((pd->pantemp-pd->exttemp) / (2*dt)); // par dt

	// soleil
	// temperature theorique panneau
	//$pantemp = $pantemp + $extsol * $pansurf * coef;
	// calcul bidon
	// extsol devrait etre en watt/m2 pour la region concerne
	// coef depend d'une infinité de parametres
	// rendement capteur, orientation, etc
	// ici on veut que la temp du capteur evolue suivant extsol
pd->pantemp = pd->pantemp + pd->extsol * pd->pansurf / 160;
	// limite temp panneau
if ( pd->pantemp > ((pd->exttemp + 20) * 3))
  pd->pantemp =  (pd->exttemp + 20) * 3;

strcpy((char*)pd->etat,"en action");

	// activation echange
if (((int)pd->pantemp - (int)pd->baltemp) > 10 && (int)pd->baltemp <= 80)	{
  strcpy((char*)pd->etat,"echange en cours");
	//dtvit = volume d'echange par dt
dtvit = pd->pompvit / dt;	//volume d'echange par dt
	// var temp ballon
pd->baltemp = (pd->baltemp*(pd->balvol-dtvit) + pd->pantemp*dtvit) / pd->balvol;
	// var temp panneau perte
pd->pantemp = pd->pantemp - ((pd->pantemp-pd->baltemp) / (5 * pd->pansurf)); // par dt
				}
  pd->horlog=pd->horlog+1;
  graph((FENGRA *) &fg);
	// on veut un stop tous les 30
if ( ((int)pd->horlog  % 30) == 0)	{
 fstop(NULL,NULL);
 strcpy((char*)pd->etat,"stop programme");
			}
if (pd->horlog <= MAXTEMPS ) return TRUE;
else {
  strcpy((char*)pd->etat,"arret");
  return FALSE;
    }
}

// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_PSOL*) &psol);
aff_fen2c_sais((F2C *) &f1,(DATA_PSOL*) &psol);
gtk_widget_show_all(f1.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
	// iteration declanchee tous les xx en 1/1000 de seconde
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_PSOL*) &psol) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_PSOL*) &psol);
	}
if ( !ret1 )	{
	fstop(NULL,NULL);
	if ( fis != NULL) { fclose(fis); fis = NULL;	}
	return FALSE;
			}
return TRUE;
}

	// on reinitialise (apres saisie)
void fraz(GtkWidget *widget,gpointer data)
{
DATA_PSOL* pd = &psol;
char *pnf = NULL;
pd->horlog=0;
fis = NULL;
	//  fichier de donnee
if ( question(3) == 0)	{
 open_fiecsv();
 if   ( fis != NULL )	{
  pnf = strrchr (fiecsvs, '/');
  if ( pnf != NULL)  strcpy((char*)pd->fidon,(pnf+1));
  else strcpy((char*)pd->fidon,"xxxxx");
  lize();	// saute le 1er enreg
			}
			}
//pd->baltemp = pd->baltemp0;
//pd->temp = pd->temp0;
//pd->pantemp = 0;
//strcpy((char*)pd->etat,"en action");
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_PSOL*) &psol);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
 cr = gdk_cairo_create(fg.pixmap);
 cairo_set_source_rgb(cr, 0, 0, 0);	
 cairo_paint (cr);
 gtk_widget_queue_draw (fg.da);  
 init_graph( (FENGRA *) &fg.wingrap); 
			}
}

void lidon()
{
	// lize charge le buffer ze avec un enregistrement valide
	// et boucle sur le fichier
 lize();
 decoup();

}

#define DECO(ww)  nbv = nbl; nbl=isol(nbl); ww = g_strtod(&ze[nbv],NULL);

	// recup donnees
void decoup()
{
int nbl,nbv;
lz = strlen(ze);
//printf("lz= %d %s\n",lz,ze);
nbl = 0; nbv =0;
while ( nbl < lz)	{
 if ( ze[nbl] != '"') ze[nbv++] = ze[nbl];
 ++nbl;
			}
ze[nbv] = '\0';
lz = strlen(ze);
nbl = 0;
//hjour
 nbv = nbl;
 nbl=isol(nbl);
 psol.hjour = atoi(&ze[nbv]);
DECO(psol.extsol);
DECO(psol.exttemp);
DECO(psol.exteaut);
DECO(psol.baltemploc);
DECO(psol.consom);

}

