// Un chien essaie de rejoindre son maitre (depart sur axe x).
// Le maitre se deplace en ligne droite (depart axe y).
// chien et maitre se deplace chacun a sa vitesse (constante)
// inspiree de
// http://www.mathcurve.com  courbe du chien
// http://vivienfrederic.free.fr/#scilab courbe de poursuite
// http://ressources.univ-lemans.fr/AccesLibre/UM/Pedago/physique/02/meca/chien.html
// http://serge.mehl.free.fr/anx/cbe_chien.html
// ces  sites donnent leurs fonctions mathematiques y= f(x)
// que je n'ai pas reussi a appliquer
// voir mes tentatives fonction math() 

#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"
// sans ce define abs semble foirer ?
#define abs(x) ((x) > 0 ? (x) : -(x))

	// fonctions a renseigner obligatoirement
void inifen();
gboolean action(GtkWidget *widget,gpointer data);
void fraz(GtkWidget *widget,gpointer data);

	// autres fonctions
void init_graph(FENGRA* pfg); 
void math(FENGRA* pfg);
void chercheaa(float yy, float xx);

//   struct de toutes les variables necessaires
typedef struct  {
gfloat tps;		// compteur temps 
gfloat posmy0;		// pt depart maitre axe y
gfloat vitm;		// vitesse maitre
gfloat posmy;		// pos maitre axe y
gfloat posmx;		// pos maitre axe x
gfloat coam;		// coef a tangente maitre (pente)
gfloat dirm;		// direction maitre

gfloat poscx0;		// pt depart chien axe x
gfloat vitc;		// vitess chien
gfloat coach;		// coef a tangente chien
gfloat dydx;		// dy / dx
gfloat poscx;		// pos chien axe x
gfloat poscy;		// pos chien axe y
char etat[16];
} DATA_PSUI;

	// declaration de psui et initialisation des donnees 
DATA_PSUI psui = {
0,	//gfloat tps;		// compteur temps
-150,	//gfloat posmy0;	// pt depart maitre axe y
1,	//gfloat vitm;		// vitesse maitre
0,	//gfloat posmy;		// pos maitre axe y
0,	//gfloat posmx;		// pos maitre axe x
-4,	//gfloat coam;		// coef a tangente maitre (pente)
-1,	//gfloat dirm;		// direction maitre

300,	//gfloat poscx0;	// pt depart chien axe x
1.5,	//gfloat vitc;		// vitess chien
0,	//gfloat coach;		// coef a tangente chien
0,	//gfloat dydx;		// dy / dx
0,	//gfloat poscx;		// pos chien axe x
0,	//gfloat poscy;		// pos chien axe y
"...",	//char etat[15];
};
	// sauvegarde des donnees de l'iteration N-1
DATA_PSUI svpsui;

//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
	// macro deplacement dans la structure
	// ici tps premiere variable sert de reference deplacement = 0
#define DEPS(zz) (char*)&psui.zz-(char*)&psui.tps
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,DEPS(vitm),SAISNUM,10, NULL,"%0.2f","Vitesse maitre m/sec"}, 
{NULL,NULL,NULL,DEPS(posmy0),SAISNUM,10, NULL,"%0.0f","Pt depart maitre sur y (-200 a +200)"}, 
{NULL,NULL,NULL,DEPS(coam),SAISNUM,10, NULL,"%0.2f","Pente deplacement maitre (si 10000 = axe y"}, 
{NULL,NULL,NULL,DEPS(dirm),SAISNUM,10, NULL,"%0.2f","Direction depl. maitre (+1  ou -1)"}, 
{NULL,NULL,NULL,DEPS(posmy),LIBNUM,10,NULL,"%#0.2f", "Coord maitre y"}, 
{NULL,NULL,NULL,DEPS(posmx),LIBNUM,10,NULL,"%#0.2f", "Coord maitre x"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(vitc),SAISNUM,10, NULL,"%0.2f","Vitesse chien m/sec"}, 
{NULL,NULL,NULL,DEPS(poscx0),SAISNUM,10, NULL,"%0.0f","Pt depart chien sur x (-200 a +600)"}, 
{NULL,NULL,NULL,DEPS(poscy),LIBNUM,10,NULL,"%#0.2f", "Coord chien y"}, 
{NULL,NULL,NULL,DEPS(poscx),LIBNUM,10,NULL,"%#0.2f", "Coord chien x"}, 
{NULL,NULL,NULL,DEPS(dydx),LIBNUM,10,NULL,"%#0.2f", "dy / dx"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Temps en s"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
	// toujours finir par cette ligne
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS

//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"Poursuite",        // pointeur sur titre  fenetre 
280,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
350,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define HEIGR  400
#define WIGR   2 * HEIGR
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR,	// largeur fenetre 
HEIGR+40,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};


static gfloat delt = 1;	// interval de temps entre 2 iterations

	// variable pour graphe
//static float gdelt0,gdelt1,gdisv10,gdisv11,gdisv20,gdisv21;  // pour graphe
	// macro pour coordonnees graphe
//#define LARG	HEIGR 
#define DECAL  HEIGR/2
//#define COOX(zz) HEIGR*zz/(LARG) + DECAL	// axe x 
//#define COOY(zz) HEIGR - HEIGR*zz/LARG	- DECAL + 20 // axe y 
#define COOX(zz) zz + DECAL	// axe x 
#define COOY(zz) HEIGR - zz- DECAL + 20 // axe y 

	// affiche libelles et echelle sur graphe
void init_graph( FENGRA* pfg)
{ 
gint y0,x0;//,y0,x1,y1;
//char zn[40];
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
	//axes coord
  cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);	// blanc
  cairo_set_line_width (cr, 0.8);
y0=COOY(0);
  cairo_move_to(cr, 0,y0);
  cairo_line_to(cr, WIGR,y0);
//  cairo_stroke(cr);
x0=COOX(0);
y0=COOY(-HEIGR/2);
  cairo_move_to(cr,x0,y0);
y0=COOY(HEIGR/2);
  cairo_line_to(cr, x0,y0);
  cairo_stroke(cr);

/*  cairo_set_font_size(cr, 12.0);
x0=DECAL;
  sprintf(zn,"| %d m",0); 
  cairo_move_to(cr,x0, 10);
  cairo_show_text(cr, zn);

y0=COOY(0) + 10;
  cairo_move_to(cr,x0, y0);
  cairo_show_text(cr, zn);

 z= psui.largriv;
  sprintf(zn,"| %d m",z); 
x0=COOX(z);
  cairo_move_to(cr,x0, 10);
  cairo_show_text(cr, zn);*/

  cairo_destroy(cr);
}

	//  trace du graphe a partir des donnee de la fonction calcul
void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(svpsui.posmx);
y0=COOY(svpsui.posmy);
x1=COOX(psui.posmx);
y1=COOY(psui.posmy);
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// vert
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

x0=COOX(svpsui.poscx);
y0=COOY(svpsui.poscy);
x1=COOX(psui.poscx);
y1=COOY(psui.poscy);
  cairo_set_source_rgb(cr, 1.0, 0, 0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);
/*
x0=COOX(svpsui.poscx);
y0=COOY(svpsui.dydx*100);
x1=COOX(psui.poscx);
y1=COOY(psui.dydx*100);
  cairo_set_source_rgb(cr, 0, 0, 1.0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);*/

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}


//  fonctions calcul_____________________________________

//static int varvit = 0;
//static float coa,cob,coc;

static gboolean calcul(DATA_PSUI* p1)
{
double ang;
float depc,depm,dify,difx,cx,cy;
int cocy;//,comy;
	// init
if ( p1->tps == 0)	{
p1->posmy = p1->posmy0;
p1->posmx = 0;
p1->poscx = p1->poscx0;
p1->poscy = 0;
p1->dydx = 0;
			}
	// sauve valeur iter -1
memcpy((char*)&svpsui,(char*)&psui, sizeof(DATA_PSUI));

dify = p1->posmy - p1->poscy;
difx = p1->posmx - p1->poscx;

	 // + de precision abs ???
if ( abs( dify) < p1->vitc 
    && abs( difx) < p1->vitc) delt = 0.1;

 // calcul tangente chien
  p1->coach = dify / difx;	// =tang
  // depl chien
 depc = p1->vitc * delt;
if ( difx !=  0)	{
  ang = atan( p1->coach);
  if ( ang < 0) ang *= -1.0;
//	if ( (int) p1->tps % 10 == 0)
//	printf("a= %f  ang = %f dy= %f dx=%f\n", p1->coach, ang,dify,difx);
   // calcul sens et coef
  cy = depc * sin(ang);
  if ( dify < 0) cy *= -1.0;
  cx = depc * cos(ang);
  if ( difx < 0) cx *= -1.0;
			}
else	{	//difx = 0;
  cx = 0;
  printf("difx = 0/n");
	}
   // coord maitre
depm = p1->vitm * delt;
if (p1->coam == 10000.0)	{
  if (p1->dirm > 0)   p1->posmy = p1->posmy + depm;	 
  else   p1->posmy = p1->posmy - depm;
				}
else	{
  ang = atan( p1->coam);
   // si coam > 0  sin + cos +
   // si coam < 0  sin - cos +
  if (p1->dirm > 0)	{
   p1->posmx = p1->posmx + depm * cos(ang);	 
   p1->posmy = p1->posmy + depm * sin(ang);	 
			}
  else	{
   p1->posmx = p1->posmx - depm * cos(ang);	
   p1->posmy = p1->posmy - depm * sin(ang);	
	} 
	}
	// coord chien
	// dydx inverse
p1->dydx = - cy / cx;
p1->poscx = p1->poscx + cx;
p1->poscy = p1->poscy + cy;
	// chien rejoint trajectoire du maitre
	if ( (int) p1->tps % 20 == 0)	{
//printf("obs vc=%f x0= %f x=%f  y=%f\n",p1->vitc,p1->poscx0,p1->poscx,p1->poscy);
//chercheaa(p1->poscy,p1->poscx);
					}
	// incremente compteur temps
p1->tps = p1->tps + delt;

  strcpy((char*)p1->etat,"en course");
  graph((FENGRA *) &fg);

	// arret
cocy=COOY(p1->poscy);
if (cocy <= 0 )	{
  strcpy((char*)p1->etat,"arret");
  return FALSE;
		}
	// arret si rencontre
//printf(" abs= %f fabs= %f\n", abs(p1->poscx -p1->posmx),fabs(p1->poscx -p1->posmx));
if ( abs(p1->poscy -p1->posmy) > p1->vitm 
    || abs(p1->poscx -p1->posmx) > p1->vitm) return TRUE;
else {
  strcpy((char*)p1->etat,"bang !");
//  math((FENGRA *) &fg);
  return FALSE;
    }
}

// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_PSUI*) &psui);
aff_fen2c_sais((F2C *) &f1,(DATA_PSUI*) &psui);
gtk_widget_show_all(f1.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
	// iteration declanchee tous les xx en 1/1000 de seconde
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_PSUI*) &psui) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_PSUI*) &psui);
	}
if ( !ret1 )	{
	fstop(NULL,NULL);
	return FALSE;
			}
return TRUE;
}

	// on reinitialise (apres saisie)
void fraz(GtkWidget *widget,gpointer data)
{
DATA_PSUI* pd = &psui;
pd->tps=0;
delt = 1;
//varvit = 0;
//strcpy((char*)pd->etat,"en action");
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_PSUI*) &psui);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(fg.pixmap);
cairo_set_source_rgb(cr, 0, 0, 0);	
cairo_paint (cr);
gtk_widget_queue_draw (fg.da);  
init_graph( (FENGRA *) &fg.wingrap); 
			}
}

// math
static float aa, bb, nn,cc;

float fonmath( float x)
{
float p1,p2,y;
p1 = pow(x/cc,1.0/(nn+1));
p2 = pow(cc/x,1.0/(nn-1));
y = ( p1 + p2) * ( x / 2.0);
/*float y1,y2,y,p1,p2;
p1 = pow(x,nn+1);
y1 = aa / (2 * (nn+1)) * p1;
p2 = pow(x,-nn+1);
y2 = 1.0 / (2 * aa * (-nn+1)) * p2;
y = y1 - y2 + bb;
//printf("x=%f y1=%f y2=%f y=%f\n",x,y1,y2,y);
*/
return y;
}

void math( FENGRA* pfg)
{
float yy,xx,svyy,svxx,p0,fa,uu;
gint x0,y0,x1,y1;
svyy = 0;
svxx = psui.poscx0;
nn = psui.vitm / psui.vitc;
uu = psui.posmy0 / psui.poscx0;
p0 = pow(1+uu*uu,1.0/2.0) -uu;
cc = psui.poscx0 * pow(p0,nn);
fa = fonmath(psui.poscx0);
bb = 0;//psui.posmy0;
/*p1 = pow(psui.poscx0,-nn+1);
aa = p1 / (psui.poscx0*2*(-nn+1));
bb= 0;
p0= (psui.posmy0 / psui.poscx0);
yy = fonmath(psui.poscx0);
bb = -yy;*/
printf("bb=%f fa=%f cc=%f\n",bb,fa, cc);

cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
cairo_set_source_rgb(cr, 1.0, 1.0, 0);	
for ( xx = psui.poscx0; xx >= 0; xx -= 5) {
//for ( xx=0; xx < 201; ++xx)	{
 yy = fonmath(xx) - fa;// + bb;
x0=COOX(svxx);
y0=COOY(svyy);
x1=COOX(xx);
y1=COOY(yy);

  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);
 svyy = yy;
 svxx = xx;
				}
cairo_destroy(cr);
}

void chercheaa(float yy, float xx)
{
float zz,p0,aw;
int trouv;
nn = psui.vitm / psui.vitc;
bb= 0;
p0= -(psui.posmy0 / psui.poscx0);
aa= 0.1; // semble ok pour calcul bb
zz = fonmath(psui.poscx0);
bb = -zz;

trouv = 0;
for ( aw = -0.2; aw < 0.2; aw += 0.001)	{
 zz = fonmath(xx);
 if ( abs( zz - yy) < 1.0) { trouv = 1; break; }
						}
if (trouv == 0) printf("nada yy=%0.2f xx=%0.2f\n",yy,xx);
else {
printf("my0=%0.0f cx0=%0.0f nn=%0.0f bb=%0.2f p0=%0.2f yy=%0.2f zz=%0.2f xx=%0.2f aw=%f\n",psui.posmy0,psui.poscx0,nn, bb, p0,yy,zz, xx,aw);
aa = aw;
	}
} 
