// demo simple
// une voiture 1 part de la ville A vers la ville B
// une voiture 2 part de la ville B vers la ville A
// connaissant la vitesse moyenne de chaque voiture, on veut calculer la distance
//  parcourue par chaque voiture et l'heure de la rencontre

#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"

	// fonctions a renseigner obligatoirement
// creer et afficher la ou les fenetres de donnees + fenetre graphe si besoin
void inifen();
// activation d'une itération de calcul
gboolean action(GtkWidget *widget,gpointer data);
// reinitialisation des variables (apres modification de donnee
void fraz(GtkWidget *widget,gpointer data);

	// autres fonctions
// initialisation du graphe (libelles)
void init_graph(FENGRA* pfg); 
// fonction de controle de saisie
int fonc_control (DEF_L_F2C *pl, int temchang);

//   struct de toutes les variables necessaires
typedef struct  {
gfloat tps;		// compteur temps 
			// doit rester premiere variable de la structure
			// car utilisee dans definition fenetre
int dist2ville;		// distance entre ville
gfloat disv1;		// km parcourus par voiture 1
gfloat vitesv1;		// vitesse voiture 1 en km/h
gfloat disv2;		//  km parcourus par voiture 2
gfloat vitesv2;		// vitesse voiture 2 en km/h
char etat[16];
gfloat disv1v2;		// distance separant les 2 voitures 
} DATA_RDV;

	// declaration de ini_rdv et initialisation des donnees 
DATA_RDV ini_rdv = {
0,	//gfloat tps;		// compteur temps
600,	//gfloat dist2ville;	// distance entre ville
0,	//gfloat disv1;		// km parcourus par voiture 1
95,	//gfloat vitesv1;		// vitesse voiture 1 en km/h
0,	//gfloat disv2;		//  km parcourus par voiture 2
45,	//gfloat vitesv2;		// vitesse voiture 2 en km/h
"inactif",	//char etat[15];
0,	//gfloat disv1v2;		// distance separant les 2 voitures 
};

//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
	// macro deplacement dans la structure
	// ici tps premiere variable sert de reference deplacement = 0
#define DEPS(zz) (char*)&ini_rdv.zz-(char*)&ini_rdv.tps
/* 1 ligne =
NULL,NULL,NULL,deplacement,type donnee,longeur,fonction,format,libelle 
  type donnee (genfen.h) 
  LIBNUM affiche nombre
  SAISNUM donnee float pouvant etre saisie (controle) et afficher
*/
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Temps en mn"}, 
{NULL,NULL,NULL,DEPS(dist2ville),SAISINT,10, NULL,"%d","Distance entre villes"}, 
	// exemple controle de saisie
{NULL,NULL,NULL,DEPS(vitesv1),SAISNUM,5,&fonc_control, "%0.0f","Vitesse voiture 1 en km/h"}, 
{NULL,NULL,NULL,DEPS(vitesv2),SAISNUM,5,&fonc_control, "%0.0f","Vitesse voiture 2 en km/h"}, 
	// saute 1 ligne
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(disv1),LIBNUM,20,NULL,"%0.2f", "Km parcourus par V1"}, 
{NULL,NULL,NULL,DEPS(disv2),LIBNUM,20,NULL,"%0.2f", "Km parcourus par V2"}, 
{NULL,NULL,NULL,DEPS(disv1v2),LIBNUM,20,NULL,"%#0.2f", "Distance entre voitures"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
	// toujours finir par cette ligne
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS

//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"Rendez Vous Voiture",        // pointeur sur titre  fenetre 
280,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
150,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define WIGR   840
#define HEIGR  480
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR+20,	// largeur fenetre 
HEIGR+50,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};

	// controle apres saisie sur les vitesses
int fonc_control (DEF_L_F2C *pl, int temchang)
{
char *pa;
float* paf;
 if ( pl == NULL) return -1;
	// temchang = 0  saisie achevee
	// temchang = 1  saisie en cours (active par signal changed)
 if ( temchang != 0) return -1;
	//  methode 1
// if ( ini_rdv.vitesv1 > 300 || ini_rdv.vitesv2 > 300)
//   messavar("La vitesse doit etre < a 300 km/h");
	//  methode 2
 pa = pl->memcell;
 paf = (float*) pa;
 if ( *paf > (float) 250)	{
   messavar("La vitesse doit etre < a 250 km/h");
   *paf = (float) 150;
				}
return 0;
}

static gfloat delt = 10;	// interval de temps entre 2 iterations

	// variable pour graphe
static float gdelt0,gdelt1,gdisv10,gdisv11,gdisv20,gdisv21;  // pour graphe
	// macro pour coordonnees graphe
#define MAXTEMPS	360
#define COOX(zz) WIGR*zz/ini_rdv.dist2ville	// axe x distance
#define COOY(zz) HEIGR - HEIGR*zz/MAXTEMPS	// axe y temps

	// affiche libelles et echelle sur graphe
void init_graph( FENGRA* pfg)
{ 
gint y0,x0,z;//,y0,x1,y1;
char zn[40];
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
  cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);	// blanc
  cairo_set_font_size(cr, 15.0);
z= ini_rdv.dist2ville / 2;
x0=COOX(z);
  sprintf(zn,"| %d Km",z); 
  cairo_move_to(cr,x0, HEIGR+20);
  cairo_show_text(cr, zn);
z = MAXTEMPS / 2;
y0=COOY(z);
  sprintf(zn,"-- %d mn",z); 
  cairo_move_to(cr,0, y0);
  cairo_show_text(cr, zn);
  cairo_destroy(cr);
}

	//  trace du graphe a partir des donnee de la fonction calcul
void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(gdisv10);
y0=COOY(gdelt0);
x1=COOX(gdisv11);
y1=COOY(gdelt1);
  cairo_set_source_rgb(cr, 0, 1.0, 0);	// vert
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

x0=COOX(gdisv20);
//y0=COOY(gdelt0);
x1=COOX(gdisv21);
//y1=COOY(gdelt1);
  cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// bleu-vert
  cairo_move_to(cr, x0,y0);
//printf("graph 2\n");
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}


//  fonctions calcul_____________________________________

static int varvit = 0;
static float svvit1;

static gboolean calcul(DATA_RDV* p1)
{
	// sauve valeurs iter precedente pour graphe ou variation
	// on peut aussi sauver toute la struct (voir autres programmes)
gdelt0 = p1->tps;
gdisv10 = p1->disv1;
gdisv20 = p1->dist2ville - p1->disv2;
	// incremente compteur temps
p1->tps = p1->tps + delt;
/*	//variante vitesses varient
if ( p1->tps >= 120 && varvit == 0)	{
 p1->vitesv1 = p1->vitesv1 - (p1->vitesv1 / 3);
 p1->vitesv2 = p1->vitesv2 + (p1->vitesv2 / 4);
 varvit = 1;
					}*/
	// variante voit1 s'arrete
if ( p1->tps == 90 )	 svvit1 = p1->vitesv1;
if ( p1->tps >= 90 && p1->tps <= 120 )	 p1->vitesv1 = 0;
if ( p1->tps > 120 )	p1->vitesv1 = svvit1;

	// incremente distance parcourue par voiture 1 pendant interval temps
p1->disv1 = p1->disv1 + (p1->vitesv1 * delt /(float)60);
	// incremente distance parcourue par voiture 2 pendant interval temps
p1->disv2 = p1->disv2 + (p1->vitesv2 * delt /(float)60);
	// calcul distance entre les 2 voitures
p1->disv1v2 = p1->dist2ville - p1->disv1 -p1->disv2;
  strcpy((char*)p1->etat,"en action");
	// on diminue l'interval temps a l'approche de la solution
if (p1->disv1v2 < 50) delt=1;
if (p1->disv1v2 < 10) delt=0.1;
	// graphe
gdelt1 = p1->tps;
gdisv11 = p1->disv1;
gdisv21 = p1->dist2ville - p1->disv2;
  graph((FENGRA *) &fg);

	// arret quand distance devient nulle
if (p1->disv1v2 > 0) return TRUE;
else {
  strcpy((char*)p1->etat,"arret");
  return FALSE;
    }
}

// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_RDV*) &ini_rdv);
aff_fen2c_sais((F2C *) &f1,(DATA_RDV*) &ini_rdv);
gtk_widget_show_all(f1.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
	// iteration declanchee tous les xx en 1/1000 de seconde
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_RDV*) &ini_rdv) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_RDV*) &ini_rdv);
	}
if ( !ret1 )	{
	fstop(NULL,NULL);
	return FALSE;
			}
return TRUE;
}

	// on reinitialise (apres saisie)
void fraz(GtkWidget *widget,gpointer data)
{
DATA_RDV* pd = &ini_rdv;
pd->tps=0;
pd->disv1 =0;
pd->disv2 = 0;
pd->disv1v2 = 0;
delt = 10;
varvit = 0;
//strcpy((char*)pd->etat,"en action");
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_RDV*) &ini_rdv);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(fg.pixmap);
cairo_set_source_rgb(cr, 0, 0, 0);	
cairo_paint (cr);
gtk_widget_queue_draw (fg.da);  
init_graph( (FENGRA *) &fg.wingrap); 
			}
}

